`timescale 1 ns / 1 ps

module keylog(
	input clk, //24MHz
	input rst_n,
	
	input dm,
	input dp,
	
	output tx
);

wire data;
wire data_empty;
wire data_clk;

wire [3:0] buffer_addr;
wire [7:0] buffer;
wire buffer_clk;

usb_rx usb_rx_m(
	.clk(clk),
	.rst_n(rst_n),
	
	.dm(dm),
	.dp(dp),
	
	.data(data),
	.data_empty(data_empty),
	.data_clk(data_clk)
);

get_data get_data_m(
	.clk(clk),
	.rst_n(rst_n),
	
	.data(data),
	.data_empty(data_empty),
	.data_clk(data_clk),
	
	
	.buffer_addr(buffer_addr),
	
	.buffer(buffer),
	.buffer_clk(buffer_clk)
);

uart_tx uart_tx_m(
	.clk(clk),
	.rst_n(rst_n),
	
	.buffer(buffer),
	.buffer_clk(buffer_clk),
	
	.buffer_addr(buffer_addr),
	
	.tx(tx)
);
	
endmodule
